
/** Die Klasse PatternGenerator baut den (triren) Baum auf, der aus den Pattern der einzelnen Gene und deren Drehungen besteht.
 *
 * Stand: 09.07.2001
 */
public class PatternGenerator{
    protected Knoten tree;

    MirrorGenerator mirror;


    /** Der Konstruktor erwartet ein Genom als Paramter. Alle Gene in diesem Genom werden in alle im 3-dimensionalen Fall mglichen Richtungen gedreht.
     * Die Richtung, in die gegangen werden soll, die ein Gen ebenfalls enthlt, wird dabei entsprechend mitgedreht.
     *
     * Gendert: ?
     *
     * @param genom Genom aus dem der Baum aufgebaut werden soll
     */
    public PatternGenerator( Genom genom ){
        tree = new Knoten();

        int sizeOfSide = (int)Math.pow( (double)genom.getPatternOfGen(0).length,(double)1/3 );
        mirror = MirrorGenerator.getMirror( sizeOfSide );

        // fr die Richtung, die uns ein Gen gibt gilt 0<=Richtung<=25
        int[] directionChanger = generateDirectionChanger( genom.getPatternOfGen(0));

        System.out.print( genom.toString());

        for (int i = 0; i < genom.size(); i++){
            insertInTree(i,genom.getPatternOfGen(i), genom.getBuildOfGen(i), directionChanger[ genom.getDirectionOfGen(i) ]);
        }
    }


    /** Liefert den erzeugten Baum (bzw. eine Referenz auf dessen Wurzel).
     *
     * Gendert: ?
     * @return Knoten die Wurzel des Baums
     */
    public Knoten getTree(){
        return tree;
    }

    // eingefgt 18.06.2001 (Steffen)
    //gendert auf temp.lemgth/2 am 05.07.2001: Ist das wohl richtig?!?
    protected int[] generateDirectionChanger( char[] array ){
        int[] temp = new int[ array.length - 1];
        for( int i = 0; i < temp.length/2 ; i++){
            temp[i] = i;
        }
        for( int i = temp.length/2; i < temp.length; i++){
            temp[i] = i + 1;
        }
        return temp;
    }

    protected void insertInTree( int indexOfGen, char[] array, boolean build, int direction ){
        int numberOfJoker = countJoker( array );


        for( int i = 0; i < mirror.length; i++ ){
            char[] data = mirrorPattern( array, mirror.get(i) );

            int dir = calcDirection( direction, mirror.get(i));

            Action newAction = null;
            try{
                newAction = new Action( build, dir, numberOfJoker, indexOfGen );
            }catch (ArrayIndexOutOfBoundsException e) {
                System.out.println("Sehr geehrter GenPool, deine Richtung ist SCH...!");
            }

            try{		
                tree.addRule(  new Rule( data, newAction ) );
            }catch( PatternNotAddableInTreeException e ){
                System.out.println( "Kann Pattern nicht in Baum einfgen." );
            }
        }
    }

    protected int countJoker( char[] array ){
        int counter = 0;
        for( int i = 0; i<array.length; i++ ){
            if( array[i] == Nest.JOKER ){
                counter++;
            }
        }

        return counter;
    }

    // Gendert: 19.06.2001 (Steffen)
    protected char[] mirrorPattern( char[] array, int[] lineInMirror ){
        char[] result = new char[ array.length ];
        for( int i = 0; i < array.length; i++ ){
            result[i] =  array[ lineInMirror[i]];
        }

        return result;
    }

    protected int calcDirection( int oldDirection, int[] lineInMirror )
        throws ArrayIndexOutOfBoundsException{
        return lineInMirror[ oldDirection ];
    }
}


