
import java.util.Enumeration;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
import javax.vecmath.*;
import javax.media.j3d.*;
import com.sun.j3d.utils.geometry.Sphere;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

public class PickDragBehavior extends Behavior {

    WakeupCriterion [] mouseEvents;
    WakeupOr mouseCriterion;
    int x,y;
    int last_x,last_y;
    Canvas3D screen;
    BranchGroup pickRoot;
    PickRay pickRay=new PickRay();
    SceneGraphPath sceneGraphPath;
    ModellViewer viewport;
    boolean draging;
    Point3d eyePos=new Point3d() ,mousePos=new Point3d();
    Vector3d mouseVec;
    Transform3D transform3D=new Transform3D();

    public PickDragBehavior( Canvas3D canvas3D, BranchGroup pickRoot,ModellViewer mv)
    {
	this.screen=canvas3D;
	this.pickRoot=pickRoot;
	this.viewport=mv;
    }

    public void initialize()
    {
	x=y=last_x=last_y=0;
	mouseEvents = new WakeupCriterion[3];
	mouseEvents[0]=new WakeupOnAWTEvent(MouseEvent.MOUSE_DRAGGED);
	mouseEvents[1]=new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);
	mouseEvents[2]=new WakeupOnAWTEvent(MouseEvent.MOUSE_CLICKED);
	mouseCriterion=new WakeupOr(mouseEvents);
	wakeupOn(mouseCriterion);
    }

    public void processStimulus(Enumeration criteria)
    {
        WakeupCriterion wakeup;
	AWTEvent[] event;
	int id;
	int dx,dy;
	while(criteria.hasMoreElements())
	{
	    wakeup=(WakeupCriterion) criteria.nextElement();
	    if( wakeup instanceof WakeupOnAWTEvent)
	    {
		event= ((WakeupOnAWTEvent)wakeup).getAWTEvent();
		for(int i=0;i<event.length;i++)
		{
		    id=event[i].getID();
		    if(id==MouseEvent.MOUSE_DRAGGED)
		    {
			draging=true;
			if( ((MouseEvent)event[i]).getModifiers()==MouseEvent.BUTTON1_MASK)
			{
			    //left-mouse-drag => rotation
			    x=((MouseEvent)event[i]).getX();
			    y=((MouseEvent)event[i]).getY();
			    viewport.rotateRelativToView(last_x-x,last_y-y);
			    last_x=x;
			    last_y=y;
			}
			else if( ((MouseEvent)event[i]).getModifiers()==MouseEvent.BUTTON3_MASK)
			{
			    //right-mouse-drag => zoom
			    x=((MouseEvent)event[i]).getX();
			    y=((MouseEvent)event[i]).getY();
			    viewport.zoomRelativToView(last_y-y);
			    last_x=x;
			    last_y=y;
			}
		    }
		    else if( id== MouseEvent.MOUSE_PRESSED)
		    {
			draging=false;
			x=last_x=((MouseEvent)event[i]).getX();
			y=last_y=((MouseEvent)event[i]).getY();
		    }
		    else if(id==MouseEvent.MOUSE_CLICKED);
		    {
			//finde das angeklickte object und benachrichtige es
                          if(!draging)
			    click_Performed((MouseEvent)event[i]);
		    }
		}
	    }
	}
	wakeupOn(mouseCriterion);
    }

    public void click_Performed(MouseEvent event)
    {
	x=last_x=((MouseEvent)event).getX();
	y=last_y=((MouseEvent)event).getY();
	screen.getCenterEyeInImagePlate(eyePos);
	screen.getPixelLocationInImagePlate(x,y,mousePos);
	screen.getImagePlateToVworld(transform3D);
	transform3D.transform(eyePos);
	transform3D.transform(mousePos);
	if( screen.getView().getProjectionPolicy()==View.PARALLEL_PROJECTION)
	{
	    mouseVec=new Vector3d(0.0f,0.0f,-1.0f);
	}
	else
	{
	    mouseVec=new Vector3d();
	    mouseVec.sub(mousePos,eyePos);
	    mouseVec.normalize();
	}
	pickRay.set(mousePos,mouseVec);
	sceneGraphPath = pickRoot.pickClosest(pickRay);
	if(sceneGraphPath==null)
	 return;
	ClickableShape3D wasClicked=(ClickableShape3D)sceneGraphPath.getObject();
	wasClicked.ClickActionAppeared(event);
    }
}
