/** Die Klasse Rule dient zum Einfgen einer Action in den Baum, den PatternGenerator erzeugt.
 * Da hierfr die Action allein nicht ausreicht, wird die Action zusammen mit dem Pattern, das durch Drehen und Spiegeln
 * aus einem Genom hervorgegangen ist, in dieser Klasse gekapselt.<br>
 * Anhand des Patterns wird dann die Action in ein Blatt eingefgt.
 *
 * Stand: 09.07.2001
 */
public class Rule{
    protected char[] data;
    Action action;

    /** Der Konstruktor
     *
     * @param data Pattern
     * @param actin Action
     */
    public Rule( char[] data, Action action ){
        this.data = data;
        this.action = action;
    }

    /** Liefert die Grsse des Patterns.
     *
     * @return int dito
     */
    public int size(){
        return data.length;
    }

    /** Zum Zugriff auf das Pattern.
     *
     * @param index Index in das Patternarray
     * @return char Block an dieser Stelle
     */
    public char getStateAt( int index ){
        return data[index];
    }

    /** Zieht aus der Regel die Action wieder heraus.
     *
     * @return Action die Action, die zu dieser Regel gehrt
     */
    public Action getAction(){
        return action;
    }

    /** Die toString()-Methode fr diese Klasse gibt einfach das Pattern als String zurck (sonst nichts!).
     *
     * @return String das in diesem Objekt enthaltene Pattern als String
     */
    public String toString(){
        StringBuffer buffer = new StringBuffer();
        for( int i = 0; i<data.length;i++){
            buffer.append( ""+data[i] );
        }

        return buffer.toString();
    }
}
